
#include "utils.bas"
#include "file.bi"

const FBEAUTY_PATH = "c:\outils\formatters\fbeauty\" ' to be modified

const OPTION_UPCASE = ""
const OPTION_LOWCASE = "-l"
const OPTION_CAPITALIZED = "-c"
const OPTION_INDIVIDUAL = "-i"

const MY_OPTION = OPTION_UPCASE ' to be modified

const BAS = ".bas"
const BI = ".bi"

declare sub BeautifyFile(byval as string, byval as string, byval as string)
declare sub BeautifyDirectory(byval as string, byval as string, byval as string)

#ifdef DEBUG
dim shared ff as integer
ff = freefile()
open exepath & "\" & "log.txt" for output as #ff
#endif

if not FileExists(FBEAUTY_PATH & "fbeauty.exe") then
#ifdef DEBUG
  print #ff, "Cannot find fbeauty.exe."
  close #ff
#endif
  end
end if

if Command(1) = "" then
#ifdef DEBUG
  print #ff, "Missing parameter. File or directory expected."
  close #ff
#endif
  end
end if

if DirExists(Command(1)) then
  if FindExt(Command(1), BAS) or FindExt(Command(1), BI) then
    BeautifyDirectory(FBEAUTY_PATH & "fbeauty.exe", Command(1) & "\", MY_OPTION)
  else
#ifdef DEBUG
    print #ff, "No source file found in the directory."
#endif
  end if
elseif FileExists(Command(1)) then
  if (LCase(ExtractFileExt(Command(1))) = BAS) or (LCase(ExtractFileExt(Command(1))) = BI) then 
    BeautifyFile(FBEAUTY_PATH & "fbeauty.exe", Command(1), MY_OPTION)
  else
#ifdef DEBUG
    print #ff, "The file doesn't seem to be a FreeBASIC source file."
#endif
  end if
else
#ifdef DEBUG
  print #ff, "Invalid parameter. File or directory expected."
#endif
end if

#ifdef DEBUG
close #ff
#endif

sub GenerateFilteredFile(byval aSource as string, byval aNewFile as string, byval aFilter as string, byval aOption as string)
  dim s as string
  dim as uinteger f1, f2
  f1 = FreeFile()
  open aNewFile for output as #f1
  f2 = FreeFile()
  open pipe aFilter & " " & aOption & " < " & aSource for input as #f2
  do until Eof(f2)
    line input #f2, s
    print #f1, s
  loop
  close #f2
  close #f1
#ifdef DEBUG
  print #ff, aNewFile
#endif
end sub

sub BeautifyFile(byval aFilter as string, byval aPath as string, byval aOption as string)
  const TEMP = ".temp"
  dim s as string = ChangeFileExt(aPath, TEMP)
  Name(aPath, s)
  GenerateFilteredFile(s, aPath, aFilter, aOption)
  Kill(s)
end sub

sub BeautifyDirectory(byval aFilter as string, byval aPath as string, byval aOption as string)
  const PRESERVE_CONTENT = -1
  dim a() as string
  GetExt(aPath, BAS, a())
  GetExt(aPath, BI, a(), PRESERVE_CONTENT)
  for i as integer = LBound(a) to UBound(a)
    BeautifyFile(aFilter, aPath & a(i), aOption)
  next i
end sub
